// FullAccess
resource "azurerm_role_definition" "service_bus_fullaccess_definition" {
  name              = "service-bus-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.ServiceBus/checkNamespaceAvailability/action",
      "Microsoft.ServiceBus/checkNameAvailability/action",
      "Microsoft.ServiceBus/register/action",
      "Microsoft.ServiceBus/unregister/action",
      "Microsoft.ServiceBus/namespaces/write",
      "Microsoft.ServiceBus/namespaces/read",
      "Microsoft.ServiceBus/namespaces/Delete",
      "Microsoft.ServiceBus/namespaces/authorizationRules/action",
      "Microsoft.ServiceBus/namespaces/migrate/action",
      "Microsoft.ServiceBus/namespaces/removeAcsNamepsace/action",
      "Microsoft.ServiceBus/namespaces/operationresults/read",
      "Microsoft.ServiceBus/namespaces/authorizationRules/write",
      "Microsoft.ServiceBus/namespaces/authorizationRules/read",
      "Microsoft.ServiceBus/namespaces/authorizationRules/delete",
      "Microsoft.ServiceBus/namespaces/authorizationRules/listkeys/action",
      "Microsoft.ServiceBus/namespaces/authorizationRules/regenerateKeys/action",
      "Microsoft.ServiceBus/namespaces/messagingPlan/read",
      "Microsoft.ServiceBus/namespaces/messagingPlan/write",
      "Microsoft.ServiceBus/namespaces/queues/write",
      "Microsoft.ServiceBus/namespaces/queues/read",
      "Microsoft.ServiceBus/namespaces/queues/Delete",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/action",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/write",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/read",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/delete",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/listkeys/action",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/regenerateKeys/action",
      "Microsoft.ServiceBus/namespaces/topics/write",
      "Microsoft.ServiceBus/namespaces/topics/read",
      "Microsoft.ServiceBus/namespaces/topics/Delete",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/action",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/write",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/read",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/delete",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/listkeys/action",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/regenerateKeys/action",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/write",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/read",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/Delete",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/rules/write",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/rules/read",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/rules/Delete",
      "Microsoft.ServiceBus/sku/read",
      "Microsoft.ServiceBus/sku/regions/read",
      "Microsoft.ServiceBus/operations/read",
      "Microsoft.ServiceBus/namespaces/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.ServiceBus/namespaces/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.ServiceBus/namespaces/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.ServiceBus/namespaces/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.ServiceBus/namespaces/eventhubs/read",
      "Microsoft.ServiceBus/namespaces/disasterrecoveryconfigs/checkNameAvailability/action",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/write",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/read",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/delete",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/breakPairing/action",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/failover/action",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/authorizationRules/read",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/authorizationRules/listkeys/action",
      "Microsoft.ServiceBus/namespaces/eventGridFilters/write",
      "Microsoft.ServiceBus/namespaces/eventGridFilters/read",
      "Microsoft.ServiceBus/namespaces/eventGridFilters/delete",
      "Microsoft.ServiceBus/namespaces/ipFilterRules/read",
      "Microsoft.ServiceBus/namespaces/ipFilterRules/write",
      "Microsoft.ServiceBus/namespaces/ipFilterRules/delete",
      "Microsoft.ServiceBus/namespaces/virtualNetworkRules/read",
      "Microsoft.ServiceBus/namespaces/virtualNetworkRules/write",
      "Microsoft.ServiceBus/namespaces/virtualNetworkRules/delete",
      "Microsoft.ServiceBus/locations/deleteVirtualNetworkOrSubnets/action",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/write",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/read",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/delete",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/revert/action",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/upgrade/action",
      "Microsoft.ServiceBus/namespaces/networkrulesets/read",
      "Microsoft.ServiceBus/namespaces/networkrulesets/write",
      "Microsoft.ServiceBus/namespaces/networkrulesets/delete",
      "Microsoft.ServiceBus/namespaces/messages/send/action",
      "Microsoft.ServiceBus/namespaces/messages/receive/action",
      "Microsoft.ServiceBus/namespaces/messages/schedule/action",
      "Microsoft.ServiceBus/namespaces/messages/defer/action",
      "Microsoft.ServiceBus/namespaces/messages/setstate/action",
      "Microsoft.ServiceBus/namespaces/messages/browse/action",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "service_bus_readonly_definition" {
  name              = "service-bus-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.ServiceBus/namespaces/read",
      "Microsoft.ServiceBus/namespaces/operationresults/read",
      "Microsoft.ServiceBus/namespaces/authorizationRules/read",
      "Microsoft.ServiceBus/namespaces/messagingPlan/read",
      "Microsoft.ServiceBus/namespaces/queues/read",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/read",
      "Microsoft.ServiceBus/namespaces/topics/read",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/read",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/read",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/rules/read",
      "Microsoft.ServiceBus/sku/read",
      "Microsoft.ServiceBus/sku/regions/read",
      "Microsoft.ServiceBus/operations/read",
      "Microsoft.ServiceBus/namespaces/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.ServiceBus/namespaces/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.ServiceBus/namespaces/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.ServiceBus/namespaces/eventhubs/read",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/read",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/authorizationRules/read",
      "Microsoft.ServiceBus/namespaces/eventGridFilters/read",
      "Microsoft.ServiceBus/namespaces/ipFilterRules/read",
      "Microsoft.ServiceBus/namespaces/virtualNetworkRules/read",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/read",
      "Microsoft.ServiceBus/namespaces/networkrulesets/read",
    ]

    not_actions = [
      "Microsoft.ServiceBus/checkNamespaceAvailability/action",
      "Microsoft.ServiceBus/checkNameAvailability/action",
      "Microsoft.ServiceBus/register/action",
      "Microsoft.ServiceBus/unregister/action",
      "Microsoft.ServiceBus/namespaces/write",
      "Microsoft.ServiceBus/namespaces/Delete",
      "Microsoft.ServiceBus/namespaces/authorizationRules/action",
      "Microsoft.ServiceBus/namespaces/migrate/action",
      "Microsoft.ServiceBus/namespaces/removeAcsNamepsace/action",
      "Microsoft.ServiceBus/namespaces/authorizationRules/write",
      "Microsoft.ServiceBus/namespaces/authorizationRules/delete",
      "Microsoft.ServiceBus/namespaces/authorizationRules/listkeys/action",
      "Microsoft.ServiceBus/namespaces/authorizationRules/regenerateKeys/action",
      "Microsoft.ServiceBus/namespaces/messagingPlan/write",
      "Microsoft.ServiceBus/namespaces/queues/write",
      "Microsoft.ServiceBus/namespaces/queues/Delete",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/action",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/write",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/delete",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/listkeys/action",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/regenerateKeys/action",
      "Microsoft.ServiceBus/namespaces/topics/write",
      "Microsoft.ServiceBus/namespaces/topics/Delete",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/action",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/write",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/delete",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/listkeys/action",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/regenerateKeys/action",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/write",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/Delete",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/rules/write",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/rules/Delete",
      "Microsoft.ServiceBus/namespaces/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.ServiceBus/namespaces/disasterrecoveryconfigs/checkNameAvailability/action",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/write",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/delete",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/breakPairing/action",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/failover/action",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/authorizationRules/listkeys/action",
      "Microsoft.ServiceBus/namespaces/eventGridFilters/write",
      "Microsoft.ServiceBus/namespaces/eventGridFilters/delete",
      "Microsoft.ServiceBus/namespaces/ipFilterRules/write",
      "Microsoft.ServiceBus/namespaces/ipFilterRules/delete",
      "Microsoft.ServiceBus/namespaces/virtualNetworkRules/write",
      "Microsoft.ServiceBus/namespaces/virtualNetworkRules/delete",
      "Microsoft.ServiceBus/locations/deleteVirtualNetworkOrSubnets/action",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/write",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/delete",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/revert/action",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/upgrade/action",
      "Microsoft.ServiceBus/namespaces/networkrulesets/write",
      "Microsoft.ServiceBus/namespaces/networkrulesets/delete",
      "Microsoft.ServiceBus/namespaces/messages/send/action",
      "Microsoft.ServiceBus/namespaces/messages/receive/action",
      "Microsoft.ServiceBus/namespaces/messages/schedule/action",
      "Microsoft.ServiceBus/namespaces/messages/defer/action",
      "Microsoft.ServiceBus/namespaces/messages/setstate/action",
      "Microsoft.ServiceBus/namespaces/messages/browse/action",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "service_bus_noaccess_definition" {
  name              = "service-bus-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.ServiceBus/checkNamespaceAvailability/action",
      "Microsoft.ServiceBus/checkNameAvailability/action",
      "Microsoft.ServiceBus/register/action",
      "Microsoft.ServiceBus/unregister/action",
      "Microsoft.ServiceBus/namespaces/write",
      "Microsoft.ServiceBus/namespaces/read",
      "Microsoft.ServiceBus/namespaces/Delete",
      "Microsoft.ServiceBus/namespaces/authorizationRules/action",
      "Microsoft.ServiceBus/namespaces/migrate/action",
      "Microsoft.ServiceBus/namespaces/removeAcsNamepsace/action",
      "Microsoft.ServiceBus/namespaces/operationresults/read",
      "Microsoft.ServiceBus/namespaces/authorizationRules/write",
      "Microsoft.ServiceBus/namespaces/authorizationRules/read",
      "Microsoft.ServiceBus/namespaces/authorizationRules/delete",
      "Microsoft.ServiceBus/namespaces/authorizationRules/listkeys/action",
      "Microsoft.ServiceBus/namespaces/authorizationRules/regenerateKeys/action",
      "Microsoft.ServiceBus/namespaces/messagingPlan/read",
      "Microsoft.ServiceBus/namespaces/messagingPlan/write",
      "Microsoft.ServiceBus/namespaces/queues/write",
      "Microsoft.ServiceBus/namespaces/queues/read",
      "Microsoft.ServiceBus/namespaces/queues/Delete",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/action",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/write",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/read",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/delete",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/listkeys/action",
      "Microsoft.ServiceBus/namespaces/queues/authorizationRules/regenerateKeys/action",
      "Microsoft.ServiceBus/namespaces/topics/write",
      "Microsoft.ServiceBus/namespaces/topics/read",
      "Microsoft.ServiceBus/namespaces/topics/Delete",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/action",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/write",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/read",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/delete",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/listkeys/action",
      "Microsoft.ServiceBus/namespaces/topics/authorizationRules/regenerateKeys/action",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/write",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/read",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/Delete",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/rules/write",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/rules/read",
      "Microsoft.ServiceBus/namespaces/topics/subscriptions/rules/Delete",
      "Microsoft.ServiceBus/sku/read",
      "Microsoft.ServiceBus/sku/regions/read",
      "Microsoft.ServiceBus/operations/read",
      "Microsoft.ServiceBus/namespaces/providers/Microsoft.Insights/metricDefinitions/read",
      "Microsoft.ServiceBus/namespaces/providers/Microsoft.Insights/diagnosticSettings/read",
      "Microsoft.ServiceBus/namespaces/providers/Microsoft.Insights/diagnosticSettings/write",
      "Microsoft.ServiceBus/namespaces/providers/Microsoft.Insights/logDefinitions/read",
      "Microsoft.ServiceBus/namespaces/eventhubs/read",
      "Microsoft.ServiceBus/namespaces/disasterrecoveryconfigs/checkNameAvailability/action",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/write",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/read",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/delete",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/breakPairing/action",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/failover/action",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/authorizationRules/read",
      "Microsoft.ServiceBus/namespaces/disasterRecoveryConfigs/authorizationRules/listkeys/action",
      "Microsoft.ServiceBus/namespaces/eventGridFilters/write",
      "Microsoft.ServiceBus/namespaces/eventGridFilters/read",
      "Microsoft.ServiceBus/namespaces/eventGridFilters/delete",
      "Microsoft.ServiceBus/namespaces/ipFilterRules/read",
      "Microsoft.ServiceBus/namespaces/ipFilterRules/write",
      "Microsoft.ServiceBus/namespaces/ipFilterRules/delete",
      "Microsoft.ServiceBus/namespaces/virtualNetworkRules/read",
      "Microsoft.ServiceBus/namespaces/virtualNetworkRules/write",
      "Microsoft.ServiceBus/namespaces/virtualNetworkRules/delete",
      "Microsoft.ServiceBus/locations/deleteVirtualNetworkOrSubnets/action",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/write",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/read",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/delete",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/revert/action",
      "Microsoft.ServiceBus/namespaces/migrationConfigurations/upgrade/action",
      "Microsoft.ServiceBus/namespaces/networkrulesets/read",
      "Microsoft.ServiceBus/namespaces/networkrulesets/write",
      "Microsoft.ServiceBus/namespaces/networkrulesets/delete",
      "Microsoft.ServiceBus/namespaces/messages/send/action",
      "Microsoft.ServiceBus/namespaces/messages/receive/action",
      "Microsoft.ServiceBus/namespaces/messages/schedule/action",
      "Microsoft.ServiceBus/namespaces/messages/defer/action",
      "Microsoft.ServiceBus/namespaces/messages/setstate/action",
      "Microsoft.ServiceBus/namespaces/messages/browse/action",
    ]
  }
}
